indexing
	description: "Pseudo random number sequence of MPQ_REF numbers."
	author: "Christopher John Saunders"
	date: "$Date: 2006-12-05 (Tues, 05 Dec 2006) $"
	revision: "$Revision: 2$"

class
	MPQ_RANDOM

inherit
	COUNTABLE_SEQUENCE [MPQ_REF]

create
	make

feature {NONE} -- Initialization

	make (n: NATURAL_32) is
			-- Initialize `Current'.
			-- Numbers generated will have a nuberator
			-- between 0 and ((2 ^ `n') - 1) and a
			-- denominator between 1 and ((2 ^ `n') - 1).
		require
			n_positive: n > 0
		do
			create rnd.make (n)
			compare_objects
		ensure
			object_comparison: object_comparison
		end

feature -- Access

	i_th (i: INTEGER_32): like item is
			-- The `i'-th random number
		local
			tmp: MPZ_REF
		do
			create Result
			Result.set_numerator (rnd.i_th (i))
			tmp := rnd.i_th (i + 1)
			if tmp.is_equal (tmp.zero) then
				tmp.set_from_integer_32 (1)
			end
			Result.set_denominator (tmp)
		end

feature {NONE} -- Implementation

	rnd: MPZ_RANDOM

end
