indexing
	description: "Mathematical operations on floating-point numbers."
	author: "Christopher John Saunders"
	date: "$Date: 2006-12-05 (Tues, 05 Dec 2006) $"
	revision: "$Revision: 2$"

class
	MPF_MATH

inherit
	MPF_FUNCTIONS
		export
			{NONE} all
		end

feature -- Arithmetic

	div_2exp (f: MPF_REF; pow: NATURAL_32): MPF_REF is
			-- `f' / (2 ^ `pow').
		require
			f_not_void: f /= Void
		do
			create Result.make_precision (f.precision)
			mpf_div_2exp (Result.item, f.item, pow)
		ensure
			result_not_void: Result /= Void
		end

	mul_2exp (f: MPF_REF; pow: NATURAL_32): MPF_REF is
			-- `f' * (2 ^ `pow').
		require
			f_not_void: f /= Void
		do
			create Result.make_precision (f.precision)
			mpf_mul_2exp (Result.item, f.item, pow)
		ensure
			result_not_void: Result /= Void
		end

feature -- Root extraction

	sqrt (f: MPF_REF): MPF_REF is
			-- Square root of `f'.
		require
			f_not_void: f /= Void
		do
			create Result.make_precision (f.precision)
			mpf_sqrt (Result.item, f.item)
		ensure
			result_not_void: Result /= Void
		end

end
