indexing
	description: "Mathematical operations on rational numbers."
	author: "Christopher John Saunders"
	date: "$Date: 2006-12-05 (Tues, 05 Dec 2006) $"
	revision: "$Revision: 2$"

class
	MPQ_MATH

inherit
	MPQ_FUNCTIONS
		export
			{NONE} all
		end

feature -- Arithmetic

	div_2exp (q: MPQ_REF; pow: NATURAL_32): MPQ_REF is
			-- `f' / (2 ^ `pow').
		require
			q_not_void: q /= Void
		do
			create Result
			mpq_div_2exp (Result.item, q.item, pow)
		ensure
			result_not_void: Result /= Void
		end

	mul_2exp (q: MPQ_REF; pow: NATURAL_32): MPQ_REF is
			-- `q' * (2 ^ `pow').
		require
			q_not_void: q /= Void
		do
			create Result
			mpq_mul_2exp (Result.item, q.item, pow)
		ensure
			result_not_void: Result /= Void
		end

end
