indexing
	description: "Sequence of prime numbers."
	author: "Christopher John Saunders"
	date: "$Date: 2006-12-05 (Tues, 05 Dec 2006) $"
	revision: "$Revision: 2$"

class
	MPZ_PRIMES

inherit
	COUNTABLE_SEQUENCE [MPZ_REF]
		redefine
			default_create,
			start
		end

	MPZ_FUNCTIONS
		export
			{NONE} all
		redefine
			default_create
		end

create
	default_create

feature {NONE} -- Initialization

	default_create is
			-- Initialize `Current'.
		do
			create last_result.make_from_integer_32 (2)
			last_i := 1
			compare_objects
		ensure then
			object_comparison: object_comparison
		end

feature -- Access

	i_th (i: INTEGER): MPZ_REF is
			-- The `i'-th prime number
		local
			j: INTEGER
		do
			if i < last_i then
				start
			end
			from
				j := last_i
			until
				j = i
			loop
				mpz_nextprime (last_result.item, last_result.item)
				j := j + 1
			end
			Result := last_result.twin
			last_i := i
		end

feature -- Cursor movement

	start is
			-- Move to first position.
		do
			index := 1
			last_i := 1
			last_result.set_from_integer_32 (2)
		end

feature {NONE} -- Implementation

	last_result: like item
			-- Last found prime.

	last_i: INTEGER
			-- Last index.

end
