indexing
	description: "Enumeration of rounding modes for MPFR_REF numbers"
	author: "Christopher John Saunders"
	date: "$Date: 2006-12-05 (Tues, 05 Dec 2006) $"
	revision: "$Revision: 2$"

expanded class
	MPFR_RND_T

inherit
	ENUM
		redefine
			default_create
		end

create
	default_create, make

convert
	make ({INTEGER}),
	to_integer: {INTEGER}

feature {NONE} -- Initialization

	default_create is
			-- Initialize `Current' with `item' set to `Gmp_rand_alg_default'
		do
			make (Gmp_rndn)
		end

feature -- Access

	Gmp_rndn: INTEGER is 0
			--

	Gmp_rndz: INTEGER is 1
			--

	Gmp_rndu: INTEGER is 2
			--

	Gmp_rndd: INTEGER is 3
			--

	Gmp_rnd_max: INTEGER is 4
			--

	Gmp_rndna: INTEGER is -1
			--

feature -- Status report

	is_valid_enum (an_enum: like item): BOOLEAN
			-- Is an_enum' a valid value?
		do
			Result := (an_enum = Gmp_rndn) or else
			          (an_enum = Gmp_rndz) or else
			          (an_enum = Gmp_rndu) or else
			          (an_enum = Gmp_rndd)
		end

end
